"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveDirectoryEntrypoints = exports.dedupeSourceFiles = exports.copyFiles = exports.copyFile = void 0;
var fs = __importStar(require("fs"));
var path = __importStar(require("path"));
var mkdirp_1 = __importDefault(require("mkdirp"));
var util = __importStar(require("util"));
var passthrough = function (thing) { return thing; };
var readdir = util.promisify(fs.readdir);
var stat = util.promisify(fs.stat);
function flatten(nested) {
    return nested.reduce(function (flattened, subarray) { return __spread(flattened, subarray); }, []);
}
function copyFile(from, to) {
    if (path.resolve(from) === path.resolve(to))
        return;
    return new Promise(function (resolve) {
        var input = fs.createReadStream(from);
        var output = fs.createWriteStream(to);
        input.once("end", resolve);
        input.pipe(output);
    });
}
exports.copyFile = copyFile;
function copyFiles(filesToServe, destinationDirectory) {
    return __awaiter(this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            return [2 /*return*/, Promise.all(filesToServe.map(function (_a) {
                    var servePath = _a.servePath, sourcePath = _a.sourcePath;
                    return __awaiter(_this, void 0, void 0, function () {
                        var servingPath, destinationFilePath;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    servingPath = servePath || path.basename(sourcePath);
                                    destinationFilePath = path.resolve(destinationDirectory, servingPath.replace(/^\//, ""));
                                    if (destinationFilePath.substr(0, destinationDirectory.length) !== destinationDirectory) {
                                        throw new Error("File would be served outside of destination directory: " + sourcePath + " => " + servingPath);
                                    }
                                    mkdirp_1.default.sync(path.dirname(destinationFilePath));
                                    return [4 /*yield*/, copyFile(sourcePath, destinationFilePath)];
                                case 1:
                                    _b.sent();
                                    return [2 /*return*/];
                            }
                        });
                    });
                }))];
        });
    });
}
exports.copyFiles = copyFiles;
function dedupeSourceFiles(basenames, dropNonSourceFiles) {
    // We don't want to include a source file and its already transpiled version as input
    var sourceExtensionsRegex = /\.(jsx?|tsx?)$/i;
    var sourceFileNames = basenames.filter(function (basename) { return basename.match(sourceExtensionsRegex); });
    var nonSourceFileNames = basenames.filter(function (basename) { return sourceFileNames.indexOf(basename) === -1; });
    var collidingSourceFileNames = sourceFileNames.reduce(function (destructured, filename) {
        var _a;
        var ext = path.extname(filename);
        var name = filename.substr(0, filename.length - ext.length);
        return __assign(__assign({}, destructured), (_a = {}, _a[name] = (destructured[name] || []).concat([ext]), _a));
    }, {});
    var dedupedSourceFileNames = Object.keys(collidingSourceFileNames).map(function (name) {
        var ext = collidingSourceFileNames[name].sort()[0];
        return "" + name + ext;
    });
    return __spread((dropNonSourceFiles ? [] : nonSourceFileNames), dedupedSourceFileNames);
}
exports.dedupeSourceFiles = dedupeSourceFiles;
function resolveDirectoryEntrypoints(entrypoints, filterFiles) {
    if (filterFiles === void 0) { filterFiles = passthrough; }
    return __awaiter(this, void 0, void 0, function () {
        var nested;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, Promise.all(entrypoints.map(function (entry) { return __awaiter(_this, void 0, void 0, function () {
                        var files, _a, subentries;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0: return [4 /*yield*/, stat(entry.sourcePath)];
                                case 1:
                                    if (!(_b.sent()).isDirectory()) return [3 /*break*/, 3];
                                    _a = filterFiles;
                                    return [4 /*yield*/, readdir(entry.sourcePath)];
                                case 2:
                                    files = _a.apply(void 0, [_b.sent()]);
                                    subentries = files.map(function (filename) { return ({
                                        servePath: entry.servePath ? path.join(entry.servePath, filename) : undefined,
                                        sourcePath: path.join(entry.sourcePath, filename)
                                    }); });
                                    return [2 /*return*/, resolveDirectoryEntrypoints(subentries)];
                                case 3: return [2 /*return*/, [entry]];
                            }
                        });
                    }); }))];
                case 1:
                    nested = _a.sent();
                    return [2 /*return*/, flatten(nested)];
            }
        });
    });
}
exports.resolveDirectoryEntrypoints = resolveDirectoryEntrypoints;
