import { Page } from "puppeteer-core";
export interface PuppetContextConfig<PluginsConfig extends {} = any> {
    argv: string[];
    plugins: PluginsConfig;
}
export declare function capturePuppetConsole(page: Page): void;
export declare function captureFailedRequests(page: Page): void;
export declare function createPuppetContextConfig(argv: string[], plugins?: any): {
    argv: string[];
    plugins: any;
};
export declare function injectPuppetContext(page: Page, contextConfig: PuppetContextConfig): Promise<void>;
export declare function subscribeToMagicLogs(page: Page, subscriber: (type: string, args: any[]) => void): () => Page;
