import { Page } from "puppeteer-core";
import { Plugin } from "./plugins";
export interface Puppet {
    on: Page["on"];
    once: Page["once"];
    off: Page["off"];
    close(): Promise<void>;
    run(argv: string[], plugins?: Plugin[]): Promise<void>;
    waitForExit(): Promise<number>;
}
export declare function spawnPuppet(bundleFilePaths: string[], serverURL: string, options: {
    headless?: boolean;
}): Promise<Puppet>;
